/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is autoHideStatusbar.
 *
 * The Initial Developer of the Original Code is
 * Rgis Caspar.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): N/A
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


/**
 * AHSWebProgressListener constructor
 */
function AHSWebProgressListener()
{
  this.initialized = false;
  /* constants */
  this.STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START;
  this.STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP;
}


/**
 * Functions needed by the ProgressListener
 */
 
AHSWebProgressListener.prototype.QueryInterface = function(aIID)
{
  var CI = Components.interfaces;
  
  if ( aIID.equals(CI.nsIWebProgressListener) || 
       aIID.equals(CI.nsISupportsWeakReference) || 
       aIID.equals(CI.nsIXULBrowserWindow) || 
       aIID.equals(CI.nsISupports) )
  {
    return this;
  }
  
  throw Components.results.NS_NOINTERFACE;
}


AHSWebProgressListener.prototype.init = function() 
{
  AHS.log("progressListener initialized", 4);
  
  if ( !this.initialized ) 
  {
    this.initialized = true;
    AHS.toogle(true); 
  }
}


AHSWebProgressListener.prototype.destroy = function()
{
  AHS.log("progressListener destroyed", 4);
  AHS.initialized = false;
  AHS.toogle(false);        
}


AHSWebProgressListener.prototype.onStateChange =
function(aProgress, aRequest, aStateFlags, aStatus)
{
  if ( !AHSPref.showonpageload() )
  {
    return;
  }
  
  if ( aStateFlags & this.STATE_START ) 
  {
    AHS.log("progressListener - start loading event", 3);
    AHS.toogle(false); 
    AHS.loading = true;
  } 
  else if ( aStateFlags & this.STATE_STOP && AHS.loading ) 
  {
    AHS.log("progressListener - stop loading event", 3);
    AHS.toogle(true);
    AHS.loading = false;
  }
}


AHSWebProgressListener.prototype.onProgressChange =
function (aWebProgress, aRequest, aCurSelfProgress, 
          aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) 
{
}


AHSWebProgressListener.prototype.onLocationChange = 
function(aWebProgress, aRequest, aLocation) 
{
}


AHSWebProgressListener.prototype.onStatusChange =
function(aWebProgress, aRequest, aStatus, aMessage) 
{
}


AHSWebProgressListener.prototype.onSecurityChange =
function(aWebProgress, aRequest, aState) 
{
}


var AHSWPL = new AHSWebProgressListener();
